<?php
if (!isset($SITE)){
	header ("Location: ../index.php");	// back to index/startpage if someone tries an
	exit;  								//  page to load without menu system//
}
$pagename='hwaGenerateHtml.php';
$SITE['wsModules'][$pagename] = 'version 1.21 2013-01-22';
#  check to see this is the real script
$pfile = basename(__FILE__);
if ($pfile <> $pagename) {
	$SITE['wsModules'][$pfile]	= 'this file loaded instead of '.$pagename;
}
echo '<!-- module '.$pfile.' ==== '.$SITE['wsModules'][$pfile]." -->\n";
#-------------------------------------------------------------------------------
# version 1.21 remove errors in icon selewction 24 hours.  colom color based on daypart
#-------------------------------------------------------------------------------
// temparray 2 starts at -30C, so add 30 to C temp
// for F subtract 2 to arrive at 0C = 32F
$tempArray2=array(
'#F6AAB1', '#F6A7B6', '#F6A5BB', '#F6A2C1', '#F6A0C7', '#F79ECD', '#F79BD4', '#F799DB', '#F796E2', '#F794EA', '#F792F3', '#F38FF7', '#EA8DF7', '#E08AF8', '#D688F8', '#CC86F8', '#C183F8', '#B681F8', '#AA7EF8', '#9E7CF8', '#9179F8', '#8477F9', '#7775F9', '#727BF9', '#7085F9', '#6D8FF9', '#6B99F9', '#68A4F9', '#66AFF9', '#64BBFA', '#61C7FA', '#5FD3FA', '#5CE0FA', '#5AEEFA', '#57FAF9', '#55FAEB', '#52FADC', '#50FBCD', '#4DFBBE', '#4BFBAE', '#48FB9E', '#46FB8D', '#43FB7C', '#41FB6A', '#3EFB58', '#3CFC46', '#40FC39', '#4FFC37', '#5DFC35', '#6DFC32', '#7DFC30', '#8DFC2D', '#9DFC2A', '#AEFD28', '#C0FD25', '#D2FD23', '#E4FD20', '#F7FD1E', '#FDF01B', '#FDDC19', '#FDC816', '#FEB414', '#FE9F11', '#FE890F', '#FE730C', '#FE5D0A', '#FE4607', '#FE2F05', '#FE1802', '#FF0000'
);
$timezone 		= $SITE['tz'];
$lat 			= $SITE['latitude'];
$long			= $SITE['longitude'];
$dateTimeFormat = $SITE['timeFormat'];
$timeFormat 	= $SITE['timeOnlyFormat'];
$dateFormat 	= $SITE['dateOnlyFormat'];
$dateLongFormat = isset($SITE['dateLongFormat'])? $SITE['dateLongFormat'] : 'l d F Y';
$utcDiff 		= date('Z');// used for graphs timestamps
$forecasts		= 0;
#echo '<pre>'; print_r($returnArray['forecast']);
# we loop through all data and build arrays for the coloms of the output.
$foundFirst	= '';
$snow		= false;
$thunder	= false;
$arrTime 	= array ();		$arrTimeGraph 	= array ();
$arrDay 	= array ();
$arrIcon	= array ();		$arrIconGraph	= array ();
$arrDesc	= array ();
$arrTemp	= array ();		$arrTempGraph	= array ();
$arrRain	= array ();		$arrRainGraph	= array ();
$arrCoR		= array ();
$arrCoT		= array ();
$arrCoS		= array ();
$arrWind	= array ();		$arrWindGraph	= array ();
$arrWdir	= array ();		$arrWdirGraph	= array ();
$arrWindIcon= array ();
$arrBaro	= array ();		$arrBaroGraph	= array ();
$graphsDays = array ();
$oldDay		= '';		// to detect day cahnges in input
$graphsData	= '';		// we store all javascript data here
$graphLines = 0;		// number of javascript data lines
$graphsStop = 0;
$graphsStart= 0;
$graphTempMin = 100;
$graphTempMax = -100;
$graphBaroMin = 2000;
$graphBaroMax = 0;
$graphRainMax = 0;
$graphWindMax = 0;
#
$rowColor		= 'row-dark';
$hwaListTable 	= '';
$hwaListTable  .= '<table class="genericTable" style="width: 100%;"><tbody>
<tr class="table-top">
<td>'.langtransstr('Period').'</td><td colspan="2">'.langtransstr('Forecast').'</td>
<td>'.langtransstr('Temperature').'</td><td>'.langtransstr('Precipitation').'<br />'.langtransstr('and chance').'</td>
<td>'.langtransstr('Wind').'</td><td>'.langtransstr('Pressure').'</td>
</tr>'.PHP_EOL;
#
$now = time();
$dataLine = $firstTime = true;
#echo '<pre>'; print_r ($returnArray); exit;
for ($i =1; $i < count($returnArray['forecast']); $i++) {
	$arr 			= $returnArray['forecast'][$i];
	if ($now > $arr['timestamp']) {continue;}
	if ($dataLine == true) {
		if ($firstTime == true) {
			$firstTime = false; 
			$hwaListTable .= myDateLinePrint($arr['timestamp']-3600);
		} else {
			$hwaListTable .= myDateLinePrint($arr['timestamp']); 
		}
		$dataLine = false; 
		$oldDay  	= $arr['date'];
		}
	if ($oldDay <> $arr['date']) {		// do we have a new day
		$oldDay  	= $arr['date'];
		$graphsDays[] = 1000 * ($arr['timestamp']+3600);
		$dataLine 	= true;
	} // 
# first the javascript graph
# time
	$arrTimeGraph[$graphLines]	= $arr['timestamp'] + $utcDiff;
# icon
	$notUsed  = $iconOut = $iconUrlOut = '';
	wsChangeIcon ('hwa',$arr['icon'], $iconOut,$arr['iconUrl'], $iconUrlOut, $notUsed);
	$arrIconGraph[$graphLines]	= str_replace ('/'.$iconOut,'_small/'.$iconOut,$iconUrlOut);
# rain	
	if (!isset ($arr['rainNU']) ) {
		$value = '-';
	} else {
		$value = $arr['rainNU'];
		if ($value > $graphRainMax) {$graphRainMax = $value;}
	}
	$arrRainGraph[$graphLines] = $value;
# baro	
	$value 			= $arr['baroNU'];
	if ($value > $graphBaroMax) {$graphBaroMax = $value;} 
	if ($value < $graphBaroMin) {$graphBaroMin = $value;} 	
	$arrBaroGraph[$graphLines]	= $value;
# temp
	$value 			= $arr['tempNU'];
	if ($value > $graphTempMax) {$graphTempMax = $value;}
	if ($value < $graphTempMin) {$graphTempMin = $value;}
	$arrTempGraph[$graphLines]	= $value;
# wind
	$value 			= $arr['windSpeedNU'];
	if ($value > $graphWindMax) {$graphWindMax = $value;}
	$arrWindGraph[$graphLines]	= $value;
	$arrWdirGraph[$graphLines]	= $arr['windDir'];
# store all javascript data	
	$graphsData	.= 	'tsv['.$graphLines.'] ="'.
					$arrTimeGraph[$graphLines].'|'.
					$arrTempGraph[$graphLines].'|'.
					$arrBaroGraph[$graphLines].'|'.
					$arrWindGraph[$graphLines].'|'.
					$arrWdirGraph[$graphLines].'|'.		
					($arrTimeGraph[$graphLines]-2*3600).'|'.$arrRainGraph[$graphLines].'|'.		
					($arrTimeGraph[$graphLines]-2*3600).'|'.$arrIconGraph[$graphLines].'";'.PHP_EOL;
				
	$graphLines++;
#
# now the hwa list table
	$hwaListTable .='<tr class="'.$rowColor.'">'.PHP_EOL;;
	if ($rowColor == 'row-dark') {$rowColor = 'row-light';} else {$rowColor =  'row-dark';}
	$start	= $arr['hour'] - 3;
	if ($start < 0) {$start = $start + 24;}
	$period = substr ('00'.$start,-2). ' : '.$arr['hour'];
	$rain = '';
	if (isset ($arr['rain']) && $arr['rain'] <> 0) {
		$rain = $arr['rain'];
	}
	if (isset ($arr['rainChance']) ) {
		if ($arr['rainChance'] <> 0) {
			$rain = $arr['rainChance'].'% '.langtransstr('chance of').' '.$arr['rain'];		
		} 
		if ($arr['snowChance'] <> 0) {
			$rain .= '<br />'.$arr['snowChance'].'% '.langtransstr('chance of').' '.langtransstr('snow');		
		} 
	}
	$temp 		= $arr['temp'];
	$color		= $tempArray2[$temp + 30];
	$tempString	= '<span class="myTemp" style="text-shadow:1px 1px black; font-weight: bolder; font-size: 200%; color: '.$color.';" >'.$temp.'&deg;</span>';	
	$windSpeed	= $arr['windSpeedNU'];
	$color		= wsBeaufortColor ($windSpeed);
	$tekst		= langtransstr(wsBeaufortText ($windSpeed));
	$windText	='<span style="background-color: '.$color.';">'.$arr['windSpeed'].' - '.$tekst.'</span>';
	$wind		= $windText.'<br />'.langtransstr ('from the').' '.langtransstr($arr['windDir']);

	$hwaListTable .='<td>'.$period.'</td><td>'.langtransstr($arr['weatherDesc']).'</td>
	<td><img src="'.$arr['iconUrl'].'" alt=""/></td><td>'.$tempString.'</td>
	<td>'.$rain.'</td><td>'.$wind.'</td><td>'.$arr['baro'].'</td></tr>'.PHP_EOL;
	if (!isset ($arr['iconL']) ) {continue;}  // skip non hwa table lines
# now we process only lines for 12 hour tables 
	$forecasts++;
	$arrTime[]	= $arr['timestamp'];
	$dayText 	= langtransstr(date('l', $arr['timestamp']));
	if ($foundFirst === '') { 			// do first time things
		if ($arr['tempHigh'] <> '' ){
			$foundFirst = 'day';
			$arrDay[]	= langtransstr('Today');
		} else  {
			$foundFirst = 'night';
			$arrDay[]	= langtransstr('Tonight');
		}			
	} else {
		if ($arr['tempHigh'] <> '' ){
			$arrDay[]	= $dayText;
		} else  {
			$arrDay[]	= langtransstr(date('l', ($arr['timestamp']-12*60*60))).' '.langtransstr('night');
		}			
	}
	$notUsed 	= $iconUrl = $iconOut = $iconUrlOut = '';
	wsChangeIcon ('hwa',$arr['iconL'], $iconOut,$arr['iconUrlL'], $iconUrlOut, $notUsed);
	$arrIcon[]	= $iconUrlOut;
	$arrDesc[]	= langtransstr($arr['weatherDescL']);
	$arrTemp[]	= $arr['tempLowNU'].$arr['tempHighNU'];
	$arrRain[]	= $arr['rainNU'];
	if (isset($arr['rainChance']) ) 	{$arrCoR[]	= $arr['rainChance']; } 	else {$arrCoR[]	= '-'; }
	if (isset($arr['thunderChance']) && $arr['thunderChance'] <> 0) {
		$arrCoT[]	= $arr['thunderChance']; $thunder	= true;
	} else {
		$arrCoT[]	= '-'; 
	}
	if (isset($arr['snowChance']) && $arr['snowChance'] <> 0) { 
		$arrCoS[]	= $arr['snowChance']; $snow	= true;
	} else {
		$arrCoS[]	= '-'; 
	}
	$arrWind[]		= $arr['windSpeed'];
#	$arrWdir[]		= $arr['windDir'];	
	$arrWindIcon[]	= $arr['windDirIcon'];
	$arrBaro[]		= $arr['baroNU'];
}
#print_r($arrDay);
$hwaListTable  .= '</tbody></table>'.PHP_EOL;
'tableIconQtip_';
$qtipTxtPlain	=	'<script type="text/javascript">'.PHP_EOL.'<!--'.PHP_EOL;
$qtipTxtPlain	.=	'$(document).ready(function() {'.PHP_EOL;
$qtipTxtIcon	=	'tableIconQtip_';
if (count($arrTime) < $topCount) {$end	= count($arrTime); } else {$end	= $topCount;}
$topCount 	= $end;
$iconWidth	= 100 / $topCount;
$tableIcons  ='
<!-- start icon output -->
<table class=" genericTable" style=" background-color: transparent;">
 <tbody>
 <tr>'.PHP_EOL;

$stringColom ='<!-- start colom output -->
<div>
<table class="verwachting" style=" border: none; width: 100%;">
  <tbody>
  <tr class="trLow">
    <td colspan="99" class="trLow"></td>
  </tr>
  <tr>
    <td class="tijd">';

$unixTime 	= $returnArray['request_info'][1]['timestamp'];
$stringColom .= date($SITE['timeFormat'] , $unixTime).'</td>';
$odd = false;
for ($i = 0; $i < $end; $i++) {
	if ($odd == true) {
		$odd = false; 
	} else {
		$odd = true;	
		$unixTime = $arrTime [$i];	
		$stringColom .= '<td class="dagNaam row-dark" colspan="2">'.langtransstr(date('l', $unixTime)).'<br /><span class="dmj">'.date($SITE['dateOnlyFormat'], $unixTime).'</span></td>
		<td style="width: 6px;"></td>'.PHP_EOL;	
	}
	$tableIcons  .=  '<td width="'.$iconWidth.'%" class= "'.$qtipTxtIcon.$i.'">'.$arrDay[$i].'</td>'.PHP_EOL;
}
$tableIcons  .= '</tr>
<tr>'.PHP_EOL;
$stringColom .= '</tr>
  <tr>
    <td class="stationnaam table-top" colspan="99">'.$SITE['organ'].'</td>
  </tr>
  <tr class="">
    <td class="stationurl row-dark" colspan="99">'.$SITE['siteUrl'].'</td>
  </tr>
  <tr>
    <td class="toelichting">'.langtransstr('Forecast').'</td>'.PHP_EOL;;
$odd = false;
if (!$foundFirst = 'day') {
	$tekst 				= 'min/max';
	$leftString			= '<td class="lwaarden row-dark">';
	$leftStringBottom	= '<td class="lwaarden row-dark" style = "border-bottom-width: 1px;">';
	$rightString		= '<td class="rwaarden">';
	$rightStringBottom	= '<td class="rwaarden" style = "border-bottom-width: 1px;">';
} else {
	$tekst 				= 'max/min';
	$leftString			= '<td class="lwaarden ">';
	$leftStringBottom	= '<td class="lwaarden" style = "border-bottom-width: 1px;">';	
	$rightString		= '<td class="rwaarden row-dark">';
	$rightStringBottom	= '<td class="rwaarden row-dark" style = "border-bottom-width: 1px;">';
}
for ($i = 0; $i < $end; $i++) {
	$icon = '<img src="'.$arrIcon[$i].'" alt ="" width ="40px" title="'.$arrDesc[$i].'"/>';
	if ($odd == false) {
		$odd = true;	    
		$stringColom .= $leftString.$icon.'</td>';			
	} else {
		$odd = false;	
		$stringColom .= $rightString.$icon.'</td>';
		$stringColom .= '<td></td>'.PHP_EOL;
	}
	$tableIcons  .=  '<td width="'.$iconWidth.'%" class= "'.$qtipTxtIcon.$i.'">'.$icon.'<br />'.$arrDesc[$i].'</td>'.PHP_EOL;
}
$tableIcons  .= '</tr>
<tr>'.PHP_EOL;
$stringColom .= '
  </tr>  
  <tr>
    <td class="toelichting">';
if (!$foundFirst = 'day') {
	$tekst 				= 'min/max';
	$leftString			= '<td class="lwaarden row-dark">';
	$leftStringBottom	= '<td class="lwaarden row-dark" style = "border-bottom-width: 1px;">';
	$rightString		= '<td class="rwaarden">';
	$rightStringBottom	= '<td class="rwaarden" style = "border-bottom-width: 1px;">';
} else {
	$tekst 				= 'max/min';
	$leftString			= '<td class="lwaarden ">';
	$leftStringBottom	= '<td class="lwaarden" style = "border-bottom-width: 1px;">';	
	$rightString		= '<td class="rwaarden row-dark">';
	$rightStringBottom	= '<td class="rwaarden row-dark" style = "border-bottom-width: 1px;">';
}
$stringColom .= langtransstr('Temperature'). ' '.langtransstr($tekst).' '.$SITE['uomTemp'].'</td>';
$odd = false;
for ($i = 0; $i < $end; $i++) {
	if ($odd == false) {
		$odd = true;	    
		$stringColom .= $leftString.$arrTemp[$i].'</td>';			
	} else {
		$odd = false;	
		$stringColom .= $rightString.$arrTemp[$i].'</td>';
		$stringColom .= '<td></td>'.PHP_EOL;
	}
	$temp = round($arrTemp[$i]);
	if (!strpos ($SITE['uomTemp'], 'C') ) { // for the color lookup we need C as unit
		$temp = round(wsConvertTemperature($value, 'F', 'C')  ); 
	}
	$color = $tempArray2[$temp + 30];
	$string = '<span class="myTemp" style="text-shadow:1px 1px black; font-weight: bolder; font-size: 200%; color: '.$color.';" >'.$temp.'&deg;</span>';	
	$tableIcons  .=  '<td>'.$string.'</td>'.PHP_EOL;
}
$stringColom .= '
  </tr>
  <tr>
    <td class="toelichting">'.langtransstr('Pressure').' ('.$SITE['uomBaro'].')</td>';
$odd = false;
for ($i = 0; $i < $end; $i++) {
	if ($odd == false) {
		$odd = true;	    
		$stringColom .= $leftString.$arrBaro[$i].'</td>';			
	} else {
		$odd = false;	
		$stringColom .= $rightString.$arrBaro[$i].'</td>';
		$stringColom .= '<td></td>'.PHP_EOL;
	}
}
$tableIcons  .= '</tr>
<tr>'.PHP_EOL;
$stringColom .= '
  </tr>  
  <tr>
    <td class="toelichting">'.langtransstr('Amount of rain').' ('.$SITE['uomRain'].')</td>';
$odd = false;
for ($i = 0; $i < $end; $i++) {
	if ($odd == false) {
		$odd = true;	    
		$stringColom .= $leftString.$arrRain[$i].'</td>';			
	} else {
		$odd = false;	
		$stringColom .= $rightString.$arrRain[$i].'</td>';
		$stringColom .= '<td></td>'.PHP_EOL;
	}
	if ($arrCoR[$i] > 5) {$tableIcons  .=  '<td>'.$arrRain[$i].$SITE['uomRain'].'<br />'.$arrCoR[$i].':%</td>'.PHP_EOL;} else {$tableIcons  .=  '<td>-</td>'.PHP_EOL;}
}
$tableIcons  .= '</tr>
<tr>'.PHP_EOL;
$stringColom .= '
  </tr>

  <tr>
    <td class="toelichting">'.langtransstr('Chance of rain').'(%)</td>';
$odd = false;
for ($i = 0; $i < $end; $i++) {
	if ($odd == false) {
		$odd = true;	    
		$stringColom .= $leftString.$arrCoR[$i].'</td>';			
	} else {
		$odd = false;	
		$stringColom .= $rightString.$arrCoR[$i].'</td>';
		$stringColom .= '<td></td>'.PHP_EOL;
	}
}
$stringColom .= '
  </tr>';
if ($thunder == true) {
	$stringColom .= '
  <tr>
	<td class="toelichting">'.langtransstr('Chance of Thunder').'(%)</td>';
	$odd = false;
	for ($i = 0; $i < $end; $i++) {
		if ($odd == false) {
			$odd = true;	    
			$stringColom .= $leftString.$arrCoT[$i].'</td>';			
		} else {
			$odd = false;	
			$stringColom .= $rightString.$arrCoT[$i].'</td>';
			$stringColom .= '<td></td>'.PHP_EOL;
		}
	}
	$stringColom .= '
  </tr>';
} 
if ($snow == true) {
	$stringColom .= '
	  <tr>
		<td class="toelichting">'.langtransstr('Chance of Snow').'(%)</td>';
	$odd = false;
	for ($i = 0; $i < $end; $i++) {
		if ($odd == false) {
			$odd = true;	    
			$stringColom .= $leftString.$arrCoS[$i].'</td>';			
		} else {
			$odd = false;	
			$stringColom .= $rightString.$arrCoS[$i].'</td>';
			$stringColom .= '<td></td>'.PHP_EOL;
		}
	}
	$stringColom .= '
  </tr>';

} 
$stringColom .= ' 
  <tr>
    <td class="toelichting">'.langtransstr('Wind direction and force ').'(Bft)</td>';
$odd = false;
for ($i = 0; $i < $end; $i++) {
	$stringWind = '<img src="'.$SITE['scriptIconsWind'].$arrWindIcon[$i].'.png" alt="" /><br />'.$arrWind[$i];
	if ($odd == false) {
		$odd = true;    
		$stringColom .=  $leftStringBottom.$stringWind.'</td>';			
	} else {
		$odd = false;	
		$stringColom .=  $rightStringBottom.$stringWind.'</td>';	
		$stringColom .=  '<td></td>'.PHP_EOL;
	}
	$tableIcons  .=  '<td>'.$stringWind.'</td>'.PHP_EOL;	
}
$tableIcons  .= '</tr>
</tbody></table>
<!-- end icon ouptput -->
'.PHP_EOL;

$stringColom .=  ' 
  </tr>
  <tr>
    <td class="samenwerking" colspan="12">Samenwerking MeteoConsult/Hetweeractueel.nl</td><td colspan="2"></td>
  </tr>
  <tr class="trLow">
    <td colspan="99" height="3"></td>
  </tr>
</tbody></table>
</div>
<!-- end colom ouptput -->
'.PHP_EOL;
# now we are going to generate the javascript graphs
# calculate Y axis steps for graphs
$graphNrLines	= 6;
$graphTempMin	= floor ($graphTempMin);  // round down
$graphTempMax	= ceil 	($graphTempMax);  // round up
$stringY = '<!-- temp max: '.$graphTempMax. ' temp min: '.$graphTempMin;
$graphTempStep	= ceil(($graphTempMax - $graphTempMin) / $graphNrLines);
$stringY .= ' temp step: '.$graphTempStep;
if ($graphTempMin < 0) {
	$result = abs($graphTempMin) / $graphTempStep;
	$result = ceil ($result);
	$graphTempMin = -1 * $result * $graphTempStep;
} else {
	$result = floor ($graphTempMin / $graphTempStep );
	$graphTempMin = $result * $graphTempStep;
}
$graphTempMax	=  $graphTempMin + (1+ $graphNrLines) * $graphTempStep;
$stringY .= '  temp max: '.$graphTempMax.' temp min: '.$graphTempMin;
$graphIconYvalue = $graphTempMax - ($graphTempStep / 2);
$stringY .= ' icon: '.$graphIconYvalue. ' -->'.PHP_EOL;
#
if (preg_match("|mm|",$SITE['uomRain'])) {
	if ($graphRainMax < 3.5) {$graphRainMax = 3.5;}
	$graphRainStep	= round (($graphRainMax / $graphNrLines),1);
	$graphRainMax	= $graphRainStep * $graphNrLines;
} else {
	if ($graphRainMax < 1.3) {$graphRainMax = 14;} else {$graphRainMax = 10 * $graphRainMax;}
	$graphRainStep	= (ceil ($graphRainMax / $graphNrLines))/ 10;
	$graphRainMax	= $graphRainStep * $graphNrLines;	
}
$stringY .= '<!-- rain max: '.$graphRainMax.'   rain step: '.$graphRainStep.' -->'.PHP_EOL;
if (preg_match("|hPa|",$SITE['uomBaro'])  || preg_match("|mb|",$SITE['uomBaro'])) {
	$graphBaroDiff = $graphBaroMax - $graphBaroMin;
	if (ceil($graphBaroDiff / 15) <= $graphNrLines) {$graphBaroStep = 15; } else {$graphBaroStep = 20;}
	$graphBaroMax  = $graphBaroStep * (1 + ceil($graphBaroMax / $graphBaroStep));
	if ($graphBaroMax < 1035) { $graphBaroMax = 1035;}
	$graphBaroMin = $graphBaroMax - $graphNrLines * $graphBaroStep;
} else {  // inHg
	$graphBaroMax = 32; $graphBaroMin = 28.5; $graphBaroStep = .5;
}
$stringY .='<!-- baro max: '.$graphBaroMax.' baro min: '.$graphBaroMin.'-->'.PHP_EOL;
if ($graphWindMax < $graphNrLines) {$graphWindMax = $graphNrLines;}
$graphWindStep = ceil ($graphWindMax / $graphNrLines);
$graphWindMax  = $graphNrLines * $graphWindStep;
$stringY .='<!-- wind max: '.$graphWindMax.' wind step: '.$graphWindStep.'-->'.PHP_EOL;
echo $stringY;
#
$graphDaysString = '{';
$daysShort	= array ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
$daysLong	= array ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
for ($i = 0; $i < count ($daysShort); $i++) {
	$graphDaysString .= "'$daysShort[$i]':'".langtransstr($daysLong[$i])."',";
}
$graphDaysString .= '}';
$graphsStart 	= 1000 * ($arrTime[0]+3600);
$n				= count($arrDay)-1;
$graphsStop		= 1000 * ($arrTime[$n]+3600);
$ddays		= '';
#
for($i=1 ; $i<count($graphsDays); $i++) { //  shaded background every other day
	if($i ==  count($graphsDays)-1) {     // last incomplete day
		$ddays.= '{ from: '.$graphsDays[$i].', to: '.($graphsStop).', color: "rgba(255, 255, 255, 0.6)" },';
	} else {
		$ddays.= '{ from: '.$graphsDays[$i].', to: '.$graphsDays[$i+1].', color: "rgba(255, 255, 255, 0.6)" },';
	}
	$i++;		// skip next day
}
$from = array ('&deg;',' ','/');
$uomRain = str_replace ($from,'',$SITE['uomRain']);
$uomTemp = str_replace ($from,'',$SITE['uomTemp']);
$uomBaro = str_replace ($from,'',$SITE['uomBaro']);
$uomWind = 'bft';

$graphPart1='
<script type="text/javascript">
<!--
var days        = '.$graphDaysString.';

var globalX = [{
	type: "datetime",
	min: '.$graphsStart.',
	max: '.$graphsStop.',
	plotBands: ['.substr($ddays, 0, -1).'],
	title: {text: null},
	dateTimeLabelFormats: {day: "%H",hour: "%H"},	
	tickInterval: 6 * 3600 * 1000,	
	gridLineWidth: 0.4,      
	lineWidth: 0,
	labels: {y: 20,style:{fontWeight: \'normal\',fontSize:\'10px\'},
		formatter: function() { 
			var uh = Highcharts.dateFormat("%H", this.value);
			if(uh=="12"){return Highcharts.dateFormat("%H <br />", this.value) + days[Highcharts.dateFormat("%a", this.value)];}
			else{return Highcharts.dateFormat("%H", this.value);}
		}
	}
}];
-->
</script>
';
$graphPart1 .='
<script type="text/javascript">
<!--
var tsv = [];
'.$graphsData.'
var temps = [],
wsps = [],
baros = [],
precs = [],
icos = [];
var arr = ["00","03","06","09","12","15","18","21"];  // for windicon display
for (j = 0; j < tsv.length; j++) {
	var line =[];
	line = tsv[j].split("|");
	if(line[0].length > 0 && parseInt(line[0]) != "undefined"){
    	date = 1000 * parseInt(line[0]);
    	d = new Date (date);
		temps.push([date, parseFloat(line[1])]);
		baros.push([date, parseFloat(line[2])]);
		mkr = "'.$windIconsSmall.'" +line[4]+".png";
		str = {x:date,y:parseFloat(line[3]), marker:{symbol:\'url(\'+mkr+\')\'}};
		wsps.push(str);
		if (line[6] != \'-\') {
			date = 1000 * parseInt(line[5]);
			precs.push([date, parseFloat(line[6])]);
			date = 1000 * parseInt(line[7]);
			mkr = line[8];
			str = {x:date,y:'.$graphIconYvalue.', marker:{symbol:\'url(\'+mkr+\')\'}};
			icos.push(str); 
		}
    } // Line contains correct data           
}; // eo for each tsv

var yTitles = {color: "#000000", fontWeight: "bold", fontSize:"10px"};
var yLabels = {fontWeight: "normal",fontSize:"8px"};

$(document).ready(function() {
	Highcharts.setOptions({
		chart: {
		    spacingTop:4,
			renderTo: "placeholder",
			defaultSeriesType: "spline",
			backgroundColor: "rgba(255, 255, 255, 0.4)",
			plotBackgroundColor: {linearGradient: [0, 0, 0, 150],stops: [[0, "#ddd"],[1, "rgba(255, 255, 255, 0.4)"]]},
			plotBorderColor: "#88BCCE",
			plotBorderWidth: 0.5,
			marginRight: 60,
			marginTop: 30,
			marginLeft: 60,
			style: {fontFamily: \'"UbuntuM","Lucida Grande",Verdana,Helvetica,sans-serif\',fontSize:\'11px\'}
		},
		title: {text: ""},
		xAxis: globalX,
		lang: {thousandsSep: ""},
		credits: {enabled: false},
		plotOptions: {
			series: {marker: { radius: 0,states: {hover: {enabled: true}}}},
			spline: {lineWidth: 1.5, shadow: false, cursor: "pointer",states:{hover:{enabled: false}}},
			column: {pointWidth:15},
			areaspline: {lineWidth: 1.5, shadow: false,states:{hover:{enabled: false}}}
		},
		legend: { borderWidth: 0, align: \'center\', verticalAlign: \'top\', rtl: true},
		exporting: {enabled:false},
		tooltip: {
            positioner: function () {return { x: 0,};},
			backgroundColor: "#A2D959",
         	borderColor: "#fff",
         	borderRadius: 3,
         	borderWidth: 0,  
         	shared: true,
         	crosshairs: { width: 0.5,color: "#666"},
         	style: {lineHeight: "1.3em",fontSize: "11px",color: "#000"},
         	formatter: function() {
              var s = "" + days[Highcharts.dateFormat(\'%a\', this.x)]+" "+ Highcharts.dateFormat(\'%H:%M\', this.x) +"";
              $.each(this.points, function(i, point) {
				var unit = {
				   "'.langtransstr('Precipation').'": " '.$uomRain.'",
				   "'.langtransstr('Wind').'": " '.$uomWind.'",
				   "'.langtransstr('Temperature').'": "'.$uomTemp.'",
				   "'.langtransstr('Pressure').'": " '.$uomBaro.'"
				}[point.series.name];
				if(point.series.name != " ") {
					s += "<br/>"+point.series.name+": <b>"+point.y+unit+"</b>";
				}				     
            });  // eo each
            return s;
         }
      },
	});  // eo set general options
   chartTempData  = new Highcharts.Chart({
        chart: {renderTo: "containerTemp" },		
      	yAxis: [{  // Temp yAxis
         gridLineWidth: 0.4, min: '.$graphTempMin.',max:'.$graphTempMax.',tickInterval:'.$graphTempStep.',
         title: {text: "'.$uomTemp.'", rotation: 0, align:"high", offset: 4, y: -15, style:yTitles},
         labels: {x: -4, y: 1, formatter: function() {return this.value;},style:yLabels}       
      	},{
         lineWidth: 1,
         gridLineWidth: 0, min: 0,max:'.$graphRainMax.',tickInterval:'.$graphRainStep.', offset: 40,
         title: {text: "'.$uomRain.'", rotation: 0, align:"high", offset: 0,x: 10, y: -15, style:yTitles},
         labels: {align: "left", x: 0, y: 1, formatter: function() {return this.value;},style:yLabels}
      	},{
         gridLineWidth: 0, min: '.$graphBaroMin.',max: '.$graphBaroMax.',tickInterval: '.$graphBaroStep.',opposite: true,
         title: {text:"'.$uomBaro.'", rotation: 0, align:"high", offset: 25, y: -15, style:yTitles,},        
         labels: {align: "left",x: 4, y: 1, formatter: function() {return this.value;},style:yLabels}
      	},{ lineWidth: 1, // wind
         gridLineWidth: 0, min: 0, max: '.$graphWindMax.', tickInterval: '.$graphWindStep.', opposite: true,
         title: {text: "'.$uomWind.'", rotation:0, align:"high", offset: 15, y:-15, style:yTitles,},      
         labels: {align: "left",x: 4, y: 1, formatter: function() {return this.value;}, style:yLabels}      
       	}],
      	series: [
      		{name: "'.langtransstr('Wind').'", data: wsps,  color:"#1485DC",type: "scatter",yAxis:3, marker:{radius:2,symbol:"circle"}},
      		{name: "'.langtransstr('Pressure').'",data: baros,color: "#9ACD32",yAxis: 2,events:{legendItemClick:false}},
      		{name: "'.langtransstr('Precipation').'",data: precs,color:"#4572A7",type:"column",yAxis:1,events:{legendItemClick:false}},
      		{name: "'.langtransstr('Temperature').'",data: temps,color:"#EE7621", events:{legendItemClick:false}},
      		{name: " ",color:"#006400",type:"scatter",events:{legendItemClick:false},data:icos}
      	]
        });  // eo chart    
}); // eo document ready
-->
</script>'.PHP_EOL;	

#echo '<pre>'; print_r($returnArray); exit;
#echo '<pre>'.$hwaListTable; exit;

# ------------------------------------------------------------------
function myLongDate ($time) {
	global $dateLongFormat, $longDays, $myLongDays, $longMonths, $myLongMonths;
#
	$longDays		= array ("Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday");
	$longMonths		= array ("January","February","March","April","May","June","July","August","September","October","November","December");
#
	$longDate = date ($dateLongFormat,$time);
	$from	= array();
	$to		= array();
	for ($i = 0; $i < count($longDays); $i++) {
		if (wsfound($longDate,$longDays[$i])) {
			$from[] = $longDays[$i];
			$to[] 	= langtransstr($longDays[$i]);
			break;
		}
	}
	for ($i = 0; $i < count($longMonths); $i++) {
		if (wsfound($longDate,$longMonths[$i])) {
			$from[] = $longMonths[$i];
			$to[] 	= langtransstr($longMonths[$i]);
			break;
		}
	}
	$longDate = str_replace ($from, $to, $longDate);
	return $longDate;
}

function myDateLinePrint($time) {
	global  $SITE, $lat, $long, $rowColor, $timeFormat;
	$srise 	= date_sunrise($time, SUNFUNCS_RET_TIMESTAMP, $lat, $long);   // standard time integer
	$sset 	= date_sunset ($time, SUNFUNCS_RET_TIMESTAMP, $lat, $long);
	$dlength= $sset - $srise - 3600;
	$longDate = myLongDate ($time);
	$string='<tr class="dateline '.$rowColor.'"><td colspan="99">
<span style="float:left; position:relative;">&nbsp;<b>'.$longDate.'</b></span>
<span style="float:right;position:relative;">
	<span class="rTxt">
		<img src="'.$SITE['imgDir'].'/sunrise.png" width="24px" height="12px" alt="sunrise" />&nbsp;&nbsp;'.date($timeFormat,$srise).'&nbsp;&nbsp;
		<img src="'.$SITE['imgDir'].'/sunset.png"  width="24px" height="12px" alt="sunset" />&nbsp;&nbsp;'.date($timeFormat,$sset).'&nbsp;&nbsp;&nbsp;'.
		langtransstr('Daylength').': '.date($timeFormat,$dlength).'&nbsp;
	</span>
</span>
</td></tr>'.PHP_EOL;
	if ($rowColor == 'row-dark') {$rowColor = 'row-light';} else {$rowColor =  'row-dark';}	
	return $string;
}
# Returns whether needle was found in haystack
function wsFound($haystack, $needle){
$pos = strpos($haystack, $needle);
   if ($pos === false) {
   return false;
   } else {
   return true;
   }
}
?>